//+------------------------------------------------------------------+
//|                                                 Wilder's DMI.mq4 |
//|                                                  coded by mladen |
//|                                                                  |
//| Directional movement index was developed by Welles Wilder        |
//| A little modification by hdioxyde to show dx instead of adx      |
//+------------------------------------------------------------------+

//mod +cci +%b bar
//http://www.forex-tsd.com/suggestions-trading-systems/21454-jubilee-bar-break-system.html



#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property  indicator_buffers 2
//#property indicator_minimum  0

#property indicator_color1   Blue
#property indicator_color2   Red
//#property indicator_color3   DimGray
//#property indicator_color4   Orange
//#property indicator_color5   DimGray

#property indicator_width1   2 
#property indicator_width2   2 

//#property indicator_style1   STYLE_DOT
//#property indicator_style2   STYLE_DOT
//#property indicator_style5   STYLE_DOT

//
//
//
//
//

extern int  DMI.Length =    12;
//extern bool ShowADX    =  true;
//extern bool ShowADXR   =  false;
//extern int  Level      =  20;


extern int     bbperiod    =    10;
extern int     bbmode      =    1;
extern int     bbprice     =    0;
extern double  bbdev       =    1.5;


extern int  cciperiod   = 40;
extern int  cciprice    = 0;



extern string   note_price = "0C 1O 2H 3L 4Md 5Tp 6WghC: Md(HL/2)4,Tp(HLC/3)5,Wgh(HLCC/4)6";
extern string   ma_method_ = "SMA0 EMA1 SMMA2 LWMA3";


//
//
//
//
//

double DIp[];
double DIm[];
double ADX[];
double ADXR[];
double ADXLevel[];
double averageDIp[];
double averageDIm[];
double averageTR[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(2,DIp);    //  SetIndexLabel(0,"DI+");
   SetIndexBuffer(3,DIm);    //  SetIndexLabel(1,"DI-");
   SetIndexBuffer(0,ADX);      SetIndexLabel(0,"ADX"); SetIndexStyle(0,DRAW_HISTOGRAM); 
   SetIndexBuffer(1,ADXR);     SetIndexLabel(1,"ADXR");SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(4,ADXLevel); 
   SetIndexBuffer(5,averageDIp);
   SetIndexBuffer(6,averageDIm);
   SetIndexBuffer(7,averageTR);
      for (int i=0;i<8;i++) SetIndexEmptyValue(i,0.00);

   //
   //
   //
   //
   //

   IndicatorShortName("Wilder\'s DX ("+DMI.Length+")");
   return(0);
}

int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;
           limit=MathMin(limit,Bars-2);

   //
   //
   //
   //
   //
   
   double sf = (DMI.Length-1.0)/DMI.Length;


      for (i=limit;i>=0;i--)
      {
         double currTR  = MathMax(High[i],Close[i+1])-MathMin(Low[i],Close[i+1]);
         double DeltaHi = High[i] - High[i+1];
	      double DeltaLo = Low[i+1] - Low[i];
         double plusDM  = 0.00;
         double minusDM = 0.00;
         
            if ((DeltaHi > DeltaLo) && (DeltaHi > 0)) plusDM  = DeltaHi;
            if ((DeltaLo > DeltaHi) && (DeltaLo > 0)) minusDM = DeltaLo;      
         
         //
         //
         //
         //
         //
         
            averageDIp[i] = sf*averageDIp[i+1] + plusDM;
            averageDIm[i] = sf*averageDIm[i+1] + minusDM;
            averageTR[i]  = sf*averageTR[i+1]  + currTR;
//            ADXLevel[i]   = Level;

         //
         //
         //
         //
         //
                  
            DIp[i] = 0.00;                   
            DIm[i] = 0.00;                   
            if (averageTR[i] > 0)
               {              
                  DIp[i] = 100.00 * averageDIp[i]/averageTR[i];
                  DIm[i] = 100.00 * averageDIm[i]/averageTR[i];
               }            

//            if(ShowADX)
//               {
                  double DX;
                  if((DIp[i] + DIm[i])>0) 
                       DX = 100*MathAbs(DIp[i] - DIm[i])/(DIp[i] + DIm[i]); 
                  else DX = 0.00;
//                  ADX[i] = DX; 
//                  if(ShowADXR)
//                         ADXR[i] = 0.5*(ADX[i] + ADX[i+DMI.Length]);

//               }



      double ma   =  iMA(NULL,0,bbperiod,0,bbmode,PRICE_CLOSE,i);
      double std  =  iStdDev (NULL,0,bbperiod,0,bbmode,PRICE_CLOSE,i); 

      if (std!=0)
      double prcb = 100* (Close[i]-(ma-bbdev*std))/((ma+bbdev*std) -(ma-bbdev*std));


      double cci = iCCI(NULL,0,cciperiod,cciprice,i);


         ADX[i]=EMPTY_VALUE;     ADXR[i]=EMPTY_VALUE;


         if (cci>100 && prcb>100 && DX>40)
               {  
                  ADX[i]=High[i];   ADXR[i]=Low[i];
                  }

         if (cci<100 && prcb<0  && DX>40)
               {  
                  ADXR[i]=High[i];  ADX[i]=Low[i];
                  }



      }   
   return(0);      
}